// LiteLoader-AIDS automatic generated
/// <reference path="c:\ll3\dev/dts/helperlib/src/index.d.ts"/> 

ll.registerPlugin(
    /* name */ "STask",
    /* introduction */ "计划任务插件",
    /* version */[1, 0, 0],
);
const schedule = require('node-schedule');
const { spawn } = require('child_process');
const path = "./plugins/SCFY/STask/";
const info = "[STask]";
const config = new JsonConfigFile(path + "config.json", JSON.stringify({
    command: "stask",
    tasks: [
        {
            name: "example",
            listen: "onServerStarted",
            type: "cmd", // program|cmd
            cmd: "say 114514"
        },
        {
            name: "example2",
            listen: "MatchCron",
            cron: "15 * * * *", // cron表达式
            type: "program", // program|cmd
            program: "C:\\Windows\\System32\\notepad.exe",
            args: ""
        }
    ]
}));

function executeTask(task) {
    log("启动计划任务:" + task.name);
    if (task.type === "program") {
        const args = task.args.split(/\s+/).filter(Boolean);
        const child = spawn(task.program, args);
        child.stdout.on('data', (data) => {
            log(`任务 ${task.name} 输出: ${data.toString()}`);
        });
        child.stderr.on('data', (data) => {
            logger.error(`任务 ${task.name} 错误: ${data.toString()}`);
        });
        child.on('exit', (code) => {
            log(`任务 ${task.name} 已退出, 退出码 ${code}`);
        });
        child.on('error', (err) => {
            logger.error(`任务 ${task.name} 启动时出错: ${err.message}`);
            process.exit(1);
        });
    } else if (task.type === "cmd") {
        try {
            const result = mc.runcmdEx(task.cmd);
            log(`任务 ${task.name} 执行状态: ${result.success ? "成功" : "失败"}, 输出: ${result.output ? result.output : "无输出"}`);
        } catch (err) {
            logger.error(`任务 ${task.name} 执行命令时出错:${err}`);
        }
    } else {
        log("任务" + task.name + "未知任务类型:" + task.type);
    }
}

log("清除所有已注册的任务");
schedule.gracefulShutdown();

const scheduledJobs = []; // 用于存储已注册的任务

for (let task of config.get("tasks")) {
    switch (task.listen) {
        case "onServerStarted":
            mc.listen("onServerStarted", () => executeTask(task));
            break;
        case "MatchCron":
            try {
                // 使用 node-schedule 注册任务
                const job = schedule.scheduleJob(task.cron, () => executeTask(task));
                scheduledJobs.push(job); // 将任务存储起来以便后续管理
                log(`任务 ${task.name} 已注册，Cron 表达式: ${task.cron}`);
            } catch (err) {
                logger.error(`任务 ${task.name} 注册失败: ${err}`);
            }
            break;
        default:
            log("任务" + task.name + "未知监听类型:" + task.listen);
            break;
    }
}

function mainGUI(player) {
    var gui = mc.newSimpleForm();
    gui.setTitle(info);
    gui.addButton("执行计划任务");
    gui.addButton("查询插件信息");
    gui.addButton("取消");
    player.sendForm(gui, function (pl, id) {
        if (id == null || id == 2) {
            pl.tell(info + "表单已关闭,未收到操作!");
        } else if (id == 0) {
            runTaskGUI(pl);
        } else if (id == 1) {
            mc.runcmdEx(config.get("command") + " info");
        }
    });
}
function runTaskGUI(player) {
    var gui = mc.newCustomForm();
    gui.setTitle(info + "执行计划任务");
    gui.addDropdown("选择计划任务", listTask());
    player.sendForm(gui, function (pl, data) {
        if (data == null) {
            pl.tell(info + "表单已关闭,未收到操作!");
        } else {
            var tasks = config.get("tasks");
            var task = tasks[data[0]]
            log(task)
            executeTask(task);
            pl.tell("计划任务" + task.name + "执行成功!");
        }
    });
}
function listTask() {
    var tasks = config.get("tasks");
    var names = [];
    for (let a = 0; a < tasks.length; a++) {
        names.push(tasks[a].name);
    }
    return names;
}

const cmd = mc.newCommand(config.get("command"), "计划任务", PermType.GameMasters);
cmd.setEnum("one", ["gui", "list", "info"]);
cmd.setEnum("start", ["run", "start"]);
cmd.optional("name", ParamType.String);
cmd.mandatory("action", ParamType.Enum, "one", "action", 1);
cmd.mandatory("start_", ParamType.Enum, "start", "start_", 1);
cmd.setCallback((_cmd, ori, out, res) => {
    var action = res.action || res.start_;
    if ((["gui"].includes(action) || (action == "run" && res.name == null) || (action == "start" && res.name == null)) && !ori.player) {
        if (action == "run" || action == "start") {
            out.error(`非玩家使用${action} 指令需要指定计划任务名称!!!`);
        } else out.error(`${action} 指令只能由玩家执行!!!`);
    } else {
        switch (action) {
            case "gui":
                mainGUI(ori.player);
                break;
            case "list":
                out.success(listTask().join(", "));
                break;
            case "run":
                if (res.name == null) {
                    runTaskGUI(ori.player);
                } else {
                    var tasks = config.get("tasks");
                    if (res.name == null) {
                        out.error("未指定计划任务名称!!!");
                    } else if (!listTask().includes(res.name)) {
                        out.error("计划任务名称不存在!!!");
                    } else {
                        var task = tasks[listTask().indexOf(res.name)];
                        executeTask(task);
                        out.success("计划任务" + res.name + "执行成功!");
                    }
                }
                break;
            case "start":
                if (res.name == null) {
                    runTaskGUI(ori.player);
                } else {
                    var tasks = config.get("tasks");
                    if (res.name == null) {
                        out.error("未指定计划任务名称!!!");
                    } else if (!listTask().includes(res.name)) {
                        out.error("计划任务名称不存在!!!");
                    } else {
                        var task = tasks[listTask().indexOf(res.name)];
                        executeTask(task);
                        out.success("计划任务" + res.name + "执行成功!");
                    }
                }
                break;
            case "info":
                out.success(info + "\n版本:1.0.0\n作者:SCFY233");
                break;
            default:
                out.error("未知指令!!!");
        }
    }
});
cmd.overload(["one"]);
cmd.overload(["start", "name"]);
cmd.overload(["start"]);
cmd.setup();